



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>treap入门</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">treap入门</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 13:37:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这几天刚学了treap，听起来还行，就是调题调到恶心了&hellip;&hellip;</p>
<p>就以这道题作为板子吧（&rdquo;你本来也就做了一道题！&rdquo;）</p>
<p>　　https://www.luogu.org/problemnew/show/P3369</p>
<p>先谈谈我对treap的理解</p>
<p>treap是一种二叉搜索树，二叉搜索树是这么一回事：<br />1.可以是一棵空树<br />2.若不空，那么左子树上所有节点的值都小于根节点的值，右子树上所有节点的值都大于根节点的值<br />3.左右子树分别为一棵二叉搜索树</p>
<p>treap是由tree和heap组合而来的，可见他还满足堆的性质。<br />通过随机一个额外的数值作为优先级，来构成一个堆。可以证明，随机顺序建立的二叉排序树的期望高度是O(logn)(虽然我不会证)，所以我认为，之所以用这个随机值，就是为了防止树退化成一个链的情况，导致时间复杂度变大</p>
<p>treap最重要也是最基础的操作是旋转，分为左右旋，为什么要有旋转呢？拿插入举例，插入一个节点当然是先根据二叉搜索树的性质插入到该插入的叶节点，<br />但是为了防止其退化成一条链，我们就需要通过旋转操作使该节点的优先级满足堆的性质。<br />总结一下，旋转操作是为了在符合二叉搜索树的前提下，让树满足堆的性质。<br />那具体怎么转呢？由上文可知，改变两个节点的父子关系的同时，还有满足二叉搜索树的性质，即旋转不影响二叉搜索树的性质。<br />直接上图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1284378/201807/1284378-20180720083632043-120825584.png" /></p>
<p>（感谢hzh巨佬的图）</p>
<p>从图中可以很直观的看出，通过右旋改变了左孩子和根节点的父子关系，通过右旋改变了右孩子和根节点的关系。<br />而且可以验证，这么做二叉搜索树的性质并没有改变。<br />于是左右旋的代码就可以模拟出来</p>
<div>
<pre class="prettyprint linenums"> void right_rotate(int&amp; Q)<br />
 {<br />
     int P = lson[Q];<br />
     lson[Q] = rson[P];            //这个和下面那句不能反<br />
     rson[P] = Q;<br />
     update(Q); update(P);<br />
     Q = P;<br />
 }<br />
 void left_rotate(int&amp; Q)<br />
 {<br />
     int P = rson[Q];<br />
     rson[Q] = lson[P];<br />
     lson[P] = Q;<br />
     update(Q); update(P);<br />
     Q = P;<br />
 }</pre>
</div>
<p>其中update函数用来维护该节点储存的信息，比如字数大小，该节点深度</p>
<p>那咱们现在看看题吧。</p>
<p>对了，我维护的是小根堆，大根堆也应该是一样的吧，没试过</p>
<p>先说一下变量含义：</p>
<div>
<pre class="prettyprint linenums"> int n, root = ;                //n种操作;root记录根节点是谁（因为进行某一操作后，根节点可能改变，所以要随时记录）<br />
 int cnt = , lson[maxn], rson[maxn];    //cnt:节点总数（即每一个节点的编号）;lson[now],rson[now]:节点now的左右孩子<br />
 int val[maxn], ran[maxn], size[maxn], Cnt[maxn];    //val[now]:节点now的权值;ran[now]:随机出来的优先级;size[now]:子树大小;<br />4　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　 //Cnt[now]记录和val[now]相同的节点多少个（用来处理数字重复） </pre>
</div>
<p>第一种操作是插入。上文已述，插入是先按二叉搜索树的性质插入到叶节点，在通过旋转满足堆的性质</p>
<div>
<pre class="prettyprint linenums"> void insert(int&amp; now, int v)<br />
 {<br />
     if(!now)                //找到要插入的叶节点了<br />
     {<br />
         now = ++cnt;        //新建节点<br />
         val[now] = v;<br />
         size[now] = Cnt[now] = ;<br />
         ran[now] = rand();    //随机优先级<br />
         return;<br />
     }<br />
     if(val[now] == v) Cnt[now]++;    //若树中已经有了该数，就直接Cnt[]++了<br />
     else if(val[now] &gt; v)        //说明在左子树<br />
     {<br />
         insert(lson[now], v);    //递归寻找<br />
         if(ran[lson[now]] &lt; ran[now]) right_rotate(now);<br />
         //这一步放在了递归后面，说明此时节点已经插入好了（而且只是修改了左子树），那就判断并通过旋转维护堆<br />
     }<br />
     else<br />
     {<br />
         insert(rson[now], v);<br />
         if(ran[rson[now]] &lt; ran[now]) left_rotate(now);<br />
     }<br />
     update(now);<br />
 }</pre>
</div>
<p>第二种操作是删除。这咋办呢？如果找到后直接删除该点，那么他子树们就不知道该去哪儿了，显然乱套。<br />那怎么办呢，别忘了，旋转可以改变两个节点的父子关系，而仍不破坏这棵树，所以我们就可已找到他后，将他旋转下去直到叶节点，这时候再删除，就没什么关系了</p>
<div>
<pre class="prettyprint linenums"> void del(int&amp; now, int v)<br />
 {<br />
     if(!now) return;<br />
     if(val[now] == v)    //找到了该数<br />
     {<br />
         if(Cnt[now] &gt; ) //有重复<br />
         {<br />
             Cnt[now]--;<br />
             update(now); return;<br />
         }<br />
         else if(lson[now] &amp;&amp; rson[now])    //并没有旋转到根节点<br />
         {<br />
             left_rotate(now);     //只要选任意一棵子树旋转就行<br />
             del(lson[now], v);    //这两句等价于right_rotate(now); del(rson[now], v);<br />
         }<br />
         else                //代表只剩一个孩子了，那么就直接用他的孩子代替他，相当于把他删除<br />
         {<br />
             now = lson[now] | rson[now];    //等价于now = lson[now] ? lson[now] : rson[now]<br />
             update(now); return;<br />
         }<br />
     }<br />
     else if(val[now] &gt; v) del(lson[now], v);        //没找到就接着找<br />
     else del(rson[now], v);<br />
     update(now);<br />
 }</pre>
</div>
<p>第三种操作是查询排名，size[]就派上用场了。这跟线段树的查询第k小很像，就是查询到右子树时别忘加上左子树的大小和该点的重复个数</p>
<div>
<pre class="prettyprint linenums"> int Find_id(int now, int v)<br />
 {<br />
     if(!now) return ;<br />
     if(val[now] == v) return size[lson[now]] + ;        //别忘加上自己<br />
     if(val[now] &gt; v) return Find_id(lson[now], v);<br />
     else return Find_id(rson[now], v) + size[lson[now]] + Cnt[now];<br />
 }</pre>
</div>
<p>第四种操作是查询排名为x的数，和操作3逻辑上很想，只不过有些步骤相反，还是看代码和注释比较直观</p>
<div>
<pre class="prettyprint linenums"> int Find_num(int now, int id)<br />
 {<br />
     if(!now) return INF;<br />
     if(size[lson[now]] &gt;= id) return Find_num(lson[now], id);        //在左子树<br />
     else if(id &lt;= size[lson[now]] + Cnt[now]) return val[now];        //在左子树和自己，但因为左子树的已经走上面的语句了，就指自己<br />
     else return Find_num(rson[now], id - size[lson[now]] - Cnt[now]);    //右子树，别忘减去（跟线段树找第k小挺像）<br />
 }</pre>
</div>
<p>第五种操作是查询x的前驱。首先如果当前节点的权值比v大，那么很显然应该去左子树中找；如果当前节点的权值比v小，说明v的前驱在左子树或者当前节点就是他的前驱，但因为当前节点的左子树的右子树中（没绕，没绕）也可能存在v的前驱，所以就要在这两者之中取max，具体看代码吧</p>
<div>
<pre class="prettyprint linenums"> int Pre(int now, int v)<br />
 {<br />
     if(!now) return -INF;<br />
     if(val[now] &lt; v) return max(val[now], Pre(rson[now], v));    //前驱在右子树或是当前节点<br />
     else return Pre(lson[now], v);<br />
 }</pre>
</div>
<p>前驱都会了，那后继还会远吗？　　　　　　--雪mrclr莱</p>
<div>
<pre class="prettyprint linenums"> int Nex(int now, int v)<br />
 {<br />
     if(!now) return INF;    //相当于停止搜索和比较<br />
     if(val[now] &gt; v) return min(val[now], Nex(lson[now], v));<br />
     else return Nex(rson[now], v);<br />
 }</pre>
</div>
<p>总算写完了，发一下完整代码</p>
<div>
<pre class="prettyprint linenums"> #include&lt;cstdio&gt;<br />
 #include&lt;iostream&gt;<br />
 #include&lt;cmath&gt;<br />
 #include&lt;cstring&gt;<br />
 #include&lt;algorithm&gt;<br />
 #include&lt;cctype&gt;<br />
 using namespace std;<br />
 #define enter printf("\n")<br />
 #define space printf(" ")<br />
 typedef long long ll;<br />
 const int INF = 0x3f3f3f3f;<br />
 const int maxn = 1e5 + ;<br />
 inline ll read()<br />
 {<br />
     ll ans = ;<br />
     char ch = getchar(), last = ' ';<br />
     while(!isdigit(ch)) {last = ch; ch = getchar();}<br />
     while(isdigit(ch))<br />
     {<br />
         ans = ans *  + ch - ''; ch = getchar();<br />
     }<br />
     if(last == '-') ans = -ans;<br />
     return ans;<br />
 }<br />
 inline void write(ll x)<br />
 {<br />
     if(x &lt; ) x = -x, putchar('-');<br />
     if(x &gt;= ) write(x / );<br />
     putchar('' + x % );<br />
 }

 int n, root = ;<br />
 int cnt = , lson[maxn], rson[maxn];<br />
 int val[maxn], ran[maxn], size[maxn], Cnt[maxn];<br />
 void update(int now)<br />
 {<br />
     if(!now) return;<br />
     size[now] = size[lson[now]] + size[rson[now]] + Cnt[now];<br />
 }<br />
 void right_rotate(int&amp; Q)<br />
 {<br />
     int P = lson[Q];<br />
     lson[Q] = rson[P];<br />
     rson[P] = Q;<br />
     update(Q); update(P);<br />
     Q = P;<br />
 }<br />
 void left_rotate(int&amp; Q)<br />
 {<br />
     int P = rson[Q];<br />
     rson[Q] = lson[P];<br />
     lson[P] = Q;<br />
     update(Q); update(P);<br />
     Q = P;<br />
 }<br />
 void insert(int&amp; now, int v)<br />
 {<br />
     if(!now)<br />
     {<br />
         now = ++cnt;<br />
         val[now] = v;<br />
         size[now] = Cnt[now] = ;<br />
         ran[now] = rand();<br />
         return;<br />
     }<br />
     if(val[now] == v) Cnt[now]++;<br />
     else if(val[now] &gt; v)<br />
     {<br />
         insert(lson[now], v);<br />
         if(ran[lson[now]] &lt; ran[now]) right_rotate(now);<br />
     }<br />
     else<br />
     {<br />
         insert(rson[now], v);<br />
         if(ran[rson[now]] &lt; ran[now]) left_rotate(now);<br />
     }<br />
     update(now);<br />
 }<br />
 void del(int&amp; now, int v)<br />
 {<br />
     if(!now) return;<br />
     if(val[now] == v)<br />
     {<br />
         if(Cnt[now] &gt; )<br />
         {<br />
             Cnt[now]--;<br />
             update(now); return;<br />
         }<br />
         else if(lson[now] &amp;&amp; rson[now])<br />
         {<br />
             left_rotate(now);<br />
             del(lson[now], v);<br />
         }<br />
         else<br />
         {<br />
             now = lson[now] | rson[now];<br />
             update(now); return;<br />
         }<br />
     }<br />
     else if(val[now] &gt; v) del(lson[now], v);<br />
     else del(rson[now], v);<br />
     update(now);<br />
 }<br />
 int Find_id(int now, int v)<br />
 {<br />
     if(!now) return ;<br />
     if(val[now] == v) return size[lson[now]] + ;<br />
     if(val[now] &gt; v) return Find_id(lson[now], v);<br />
     else return Find_id(rson[now], v) + size[lson[now]] + Cnt[now];<br />
 }<br />
 int Find_num(int now, int id)<br />
 {<br />
     if(!now) return INF;<br />
     if(size[lson[now]] &gt;= id) return Find_num(lson[now], id);<br />
     else if(id &lt;= size[lson[now]] + Cnt[now]) return val[now];<br />
     else return Find_num(rson[now], id - size[lson[now]] - Cnt[now]);<br />
 }<br />
 int Pre(int now, int v)<br />
 {<br />
     if(!now) return -INF;<br />
     if(val[now] &lt; v) return max(val[now], Pre(rson[now], v));<br />
     else return Pre(lson[now], v);<br />
 }<br />
 int Nex(int now, int v)<br />
 {<br />
     if(!now) return INF;<br />
     if(val[now] &gt; v) return min(val[now], Nex(lson[now], v));<br />
     else return Nex(rson[now], v);<br />
 }

 int main()<br />
 {<br />
     n = read();<br />
     while(n--)<br />
     {<br />
         int d = read(), x = read();<br />
         if(d == ) insert(root, x);<br />
         else if(d == ) del(root, x);<br />
         else if(d == ) {write(Find_id(root, x)); enter;}<br />
         else if(d == ) {write(Find_num(root, x)); enter;}<br />
         else if(d == ) {write(Pre(root, x)); enter;}<br />
         else {write(Nex(root, x)); enter;}<br />
     }<br />
     return ;<br />
 }</pre>
</div>
<p>彩蛋：找名次写错了能MLE&hellip;&hellip;求大佬解答&hellip;&hellip;</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j2r6e8.html">庞巴迪TCMS学习笔记之一（IEC 61131-3函数）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlpzw69.html">Android Contextual Menus之二：contextual action mode</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96xp139.html">C&plus;&plus;容器的复制</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oy4kj9.html">Eclipse安装SVN插件的方法&lpar; 手动安装&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj53zz9.html">UVa11925 Generating Premutations</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o60049.html">android加载更多的图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k13m7r9.html">CSS中的 REM PX EM</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp2k6r9.html">Selenium模拟JQuery滑动解锁</a>
		</li>
						<li><a href="https://www.batexi.com/a/950zeo68.html">协议端口号（protocol port number）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgm4m48.html">关于WPF添加右击ContextMeun&comma;以及获取所绑定控件的源</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yk5mr8.html">BZOJ 2594&colon; &lbrack;Wc2006&rsqb;水管局长数据加强版 &lbrack;LCT kruskal&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey6jnx9.html">如何减小ios安装包大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey6pmm9.html">mser 最大稳定极值区域&lpar;文字区域定位&rpar;算法 附完整C代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdzmw79.html">Linux--虚拟环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp6jmzq.html">haskell实现简易计算器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rzy608.html">今天在2cto网站看到一个有关try&lbrace;&rcub;catch&lpar;&rpar;&lbrace;&rcub;finally&lbrace;&rcub;语句中含有return的讲解，理解很透彻。</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25356vq.html">springCloud之配置中心学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllp5eeq.html">mysql学习笔记--列属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rdg228.html">day21 Pythonpython time模块和datetime模块详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jv715q.html">如何干净卸载mysql</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdw6x479.html">【Linux】安装openssh-server依赖openssh-client版本错误的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1yx5w9.html">maven的注意点</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjnx2z9.html">JFace TableViewer性能改善 -- 使用VirtualTable</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv7p2k8.html">javax&period;net&period;ssl&period;SSLHandshakeException sun&period;security&period;validator&period;ValidatorException PK</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2gplx9.html">设计模式&lpar;17&rpar;--Mediator&lpar;中介者模式&rpar;行为型</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2gw2z9.html">&lbrack;World Final 2016&rsqb; Branch Assignment</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj3zor9.html">洛谷P3924 康娜的线段树&lpar;期望 前缀和&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rwg1o9.html">ReactNative仿微信朋友圈App</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj3x2r9.html">记一款bug管理系统&lpar;bugdone&period;cn&rpar;的开发过程&lpar;3&rpar; - 永久免费化</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rg0o58.html">处理 Windows 虚拟机的计划内维护通知</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
